<?php

/*
 * @version   4.0.3 Mon Apr 28 05:13:32 2014 -0700
 * @package   yoonique zoo plugin for JoomSEF and sh404sef
 * @author    yoonique[.]net
 * @copyright Copyright (C) yoonique[.]net and all rights reserved.
 * @license   http://www.gnu.org/licenses/gpl.html
 */


defined('_JEXEC') or die('Direct Access to this location is not allowed.');


defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>", JLog::INFO, 'yooniquenet');
$query = $uri->getQuery(true);
defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   query " . json_encode($query), JLog::INFO, 'yooniquenet');


if ($query['option'] <> 'com_zoo') {
	return;
}

$params = $pluginParams->toArray();

extract($params);

$dosef = true;


if (isset($query['category_id']) && $ZOO_SEF_SHOW_PRIMARY && !$ZOO_SEF_SHOW_CATEGORY) {
	if ($query['task'] == 'item') {
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   remove category_id var from item ", JLog::INFO, 'yooniquenet');
		myRemoveFromGETVarsList('category_id', $uri);
	}
}

if (isset($query['Itemid'])) {
	defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   Itemid " . $query['Itemid'], JLog::INFO, 'yooniquenet');
	if (isset($query['task']) and $query['task'] == 'feed') {
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   remove Itemid var from feed ", JLog::INFO, 'yooniquenet');
		myRemoveFromGETVarsList('Itemid', $uri);
	}
	$menu = JFactory::getApplication('site')->getMenu();
	$menuitem = $menu->getItem((int) $query['Itemid']);
	$menuparams = $menu->getParams((int) $query['Itemid']);
	if (empty($query['view']) && empty($query['task'])) {
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   task and view not present ", JLog::INFO, 'yooniquenet');
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   merging menuitem->query into query " . json_encode($menuitem->query), JLog::INFO, 'yooniquenet');
		$menuitem->query['Itemid'] = $query['Itemid'];
		$query = $menuitem->query;
		$uri->setQuery($query);
	}
	$menu_app_id = (int) $menuparams->get('application');
	$app_alias = $this->zoo->alias->application->translateIDToAlias($menu_app_id);
	defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   menu app_alias " . $app_alias, JLog::INFO, 'yooniquenet');
}


















if (empty($query['view']) && empty($query['task'])) {
	defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   task and view STILL not present -> RETURNING ", JLog::INFO, 'yooniquenet');
	return;
}

if (empty($query['task'])) {
	$zootask = $query['view'];
} else {
	$zootask = $query['task'];
}

$segments = array();

switch ($zootask) {
	case 'frontpage':
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   FRONTPAGE ", JLog::INFO, 'yooniquenet');
		if (!isset($query['page']) && !empty($menuitem->home)) {
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   is HOME ", JLog::INFO, 'yooniquenet');
			break;
		}
		if (isset($app_alias))
			$segments[] = $app_alias;
		if ($ZOO_SEF_FRONTPAGE_SHOW) {
			$segments[] = $ZOO_SEF_FRONTPAGE;
		}
		$segments[] = isset($query['page']) ? $ZOO_SEF_PAGE . $query['page'] : '';
		myRemoveFromGETVarsList('page', $uri);
		myRemoveFromGETVarsList('layout', $uri);
		break;

	case 'category':
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   CATEGORY ", JLog::INFO, 'yooniquenet');
		if (!isset($query['page']) && !empty($menuitem->home) && !isset($query['category_id'])) {
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   is HOME ", JLog::INFO, 'yooniquenet');
			break;
		}
		if (!isset($query['category_id']) && isset($query['Itemid'])) {
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   category_id is not set ", JLog::INFO, 'yooniquenet');
			$category_id = (int) $menuparams->get('category');
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   got category_id from menu " . $category_id, JLog::INFO, 'yooniquenet');
			$category = $this->zoo->table->category->get($category_id);
		}
		if (isset($query['category_id'])) {
			$category_id = (int) $query['category_id'];
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   got category_id " . $category_id . " from query", JLog::INFO, 'yooniquenet');
			$category = $this->zoo->table->category->get($category_id);
		}

		if (empty($category)) {
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   could not find category ", JLog::INFO, 'yooniquenet');
			return;
		}

		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   found category ", JLog::INFO, 'yooniquenet');

		if ($ZOO_SEF_SHOW_APP) {
			$segments[] = $this->zoo->alias->application->translateIDToAlias($category->application_id);
		}
		if ($ZOO_SEF_CATEGORY_SHOW) {
			$segments[] = $ZOO_SEF_CATEGORY;
		}
		if ($ZOO_SEF_CATEGORY_PATH) {
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   ZOO_SEF_CATEGORY_PATH ", JLog::INFO, 'yooniquenet');
			$tree = $this->zoo->table->application->get($category->application_id)->getCategoryTree(false);
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   isset tree " . isset($tree), JLog::INFO, 'yooniquenet');
			if (isset($tree[$category_id])) {
				$pathway = $tree[$category_id]->getPathway();
			}
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   isset pathway " . isset($pathway), JLog::INFO, 'yooniquenet');
			if (!empty($pathway)) {
				foreach ($pathway as $cat) {
					if ($ZOO_SEF_CATEGORY_ALIAS) {
						$segments[] = $cat->alias;
					} else {
						$segments[] = $this->zoo->string->sluggify($cat->name);
					}
					defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   path way # " . @ ++$count . "  " . $segments[key(array_slice($segments, -1, 1, TRUE))], JLog::INFO, 'yooniquenet');
				}
			}
		} else {
			if ($ZOO_SEF_CATEGORY_ALIAS) {
				$segments[] = $this->zoo->alias->category->translateIDToAlias((int) $category_id);
			} else {
				$segments[] = $this->zoo->string->sluggify($category->name);
			}
		}
		$segments[] = isset($query['page']) ? $ZOO_SEF_PAGE . $query['page'] : '';
		myRemoveFromGETVarsList('category_id', $uri);
		myRemoveFromGETVarsList('page', $uri);
		myRemoveFromGETVarsList('layout', $uri);
		break;

	case 'alphaindex':
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   ALPHAINDEX ", JLog::INFO, 'yooniquenet');
		if ($ZOO_SEF_SHOW_APP) {
			if (isset($query['app_id'])) {
				$segments[] = $this->zoo->alias->application->translateIDToAlias((int) $query['app_id']);
			}
		}
		if ($ZOO_SEF_ALPHAINDEX_SHOW) {
			$segments[] = $ZOO_SEF_ALPHAINDEX;
		}
		$segments[] = $query['alpha_char'];
		$segments[] = isset($query['page']) ? $ZOO_SEF_PAGE . $query['page'] : '';
		myRemoveFromGETVarsList('page', $uri);
		myRemoveFromGETVarsList('alpha_char', $uri);
		myRemoveFromGETVarsList('app_id', $uri);
		break;

	case 'tag':
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   TAG ", JLog::INFO, 'yooniquenet');
		if ($ZOO_SEF_SHOW_APP) {
			if (isset($query['app_id'])) {
				$segments[] = $this->zoo->alias->application->translateIDToAlias((int) $query['app_id']);
			}
		}
		$segments[] = $ZOO_SEF_TAG;
		$segments[] = $query['tag'];
		$segments[] = isset($query['page']) ? $ZOO_SEF_PAGE . $query['page'] : '';
		myRemoveFromGETVarsList('tag', $uri);
		myRemoveFromGETVarsList('page', $uri);
		myRemoveFromGETVarsList('app_id', $uri);
		break;

	case 'item':
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   ITEM ", JLog::INFO, 'yooniquenet');
		if (!isset($query['page']) && !empty($menuitem->home) && !isset($query['item_id'])) {
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   is HOME ", JLog::INFO, 'yooniquenet');
			break;
		}
		if (empty($query['item_id'])) {
			$item_id = (int) $menuparams->get('item_id', 0);
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   got item_id from menu " . $item_id, JLog::INFO, 'yooniquenet');
		} else {
			$item_id = (int) $query['item_id'];
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   got item_id " . $item_id . " from query", JLog::INFO, 'yooniquenet');
		}
		$item = $this->zoo->table->item->get($item_id);

		if (empty($item)) {
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   could not find item ", JLog::INFO, 'yooniquenet');
			return;
		}

		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   found item ", JLog::INFO, 'yooniquenet');

		if ($ZOO_SEF_SHOW_APP) {
			$segments[] = $this->zoo->alias->application->translateIDToAlias($item->application_id);
		}
		if ($ZOO_SEF_SHOW_TYPE) {
			$segments[] = $item->getType()->identifier;
		}
		if ($ZOO_SEF_ITEM_SHOW) {
			$segments[] = $ZOO_SEF_ITEM;
		}
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   identifier " . $item->getType()->identifier, JLog::INFO, 'yooniquenet');
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   date param '" . $ZOO_SEF_DATE . "'", JLog::INFO, 'yooniquenet');
		if (in_array($item->getType()->identifier, explode(",", $ZOO_SEF_DATE))) {
			$lang_current = JFactory::getLanguage();
			defined('YOONIQUE_DBG') and JLog::add(__METHOD__ . "   current language " . $lang_current->getTag(), JLog::INFO, 'yooniquenet');
			$lang_default = JComponentHelper::getParams('com_languages')->get('site', 'en-GB');
			defined('YOONIQUE_DBG') and JLog::add(__METHOD__ . "   lang_default " . $lang_default, JLog::INFO, 'yooniquenet');
			JFactory::$language = JLanguage::getInstance($lang_default);
			$tzoffset = JFactory::getConfig()->get('config.offset');
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   tzoffset '" . $tzoffset . "'", JLog::INFO, 'yooniquenet');
			$date = $this->zoo->date->create($item->created, $tzoffset);
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   date " . $date . "  " . $ZOO_SEF_DATE_FORMAT, JLog::INFO, 'yooniquenet');
			foreach (explode("/", $ZOO_SEF_DATE_FORMAT) as $format) {
				if (strpos($format, '%i') !== false) {
					defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   replacing %i with item_id", JLog::INFO, 'yooniquenet');
					$format = str_replace('%i', sprintf("%03d", $item_id), $format);
				}
				$segments[] = $this->zoo->string->sluggify($date->Format($format));
				defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   convert # " . @ ++$count . "   " . $this->zoo->string->sluggify($date->Format($format)), JLog::INFO, 'yooniquenet');
			}
			JFactory::$language = $lang_current;
		} elseif ($ZOO_SEF_CATEGORY_PATH) {
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   ZOO_SEF_CATEGORY_PATH ", JLog::INFO, 'yooniquenet');
			$tree = $this->zoo->table->application->get($item->application_id)->getCategoryTree(false);
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   isset tree " . isset($tree), JLog::INFO, 'yooniquenet');
			if ($ZOO_SEF_SHOW_PRIMARY && $item->getPrimaryCategoryId()) {
				if (isset($tree[$item->getPrimaryCategoryId()])) {
					$pathway = $tree[$item->getPrimaryCategoryId()]->getPathway();
				}
			}
			if ($ZOO_SEF_SHOW_CATEGORY && isset($query['category_id'])) {
				if (isset($tree[(int) $query['category_id']])) {
					$pathway = $tree[(int) $query['category_id']]->getPathway();
				}
			}
			if ($ZOO_SEF_SHOW_CATEGORY && !isset($query['category_id']) && $item->getPrimaryCategoryId()) {
				defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   CATEGORY NOT FOUND PICK PRIMARY ", JLog::INFO, 'yooniquenet');
				if (isset($tree[$item->getPrimaryCategoryId()])) {
					$pathway = $tree[$item->getPrimaryCategoryId()]->getPathway();
				}
			}
			defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   isset pathway " . isset($pathway), JLog::INFO, 'yooniquenet');
			if (!empty($pathway)) {
				foreach ($pathway as $cat) {
					if ($ZOO_SEF_CATEGORY_ALIAS) {
						$segments[] = $cat->alias;
					} else {
						$segments[] = $this->zoo->string->sluggify($cat->name);
					}
					defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   path way # " . @ ++$count . "  " . $segments[key(array_slice($segments, -1, 1, TRUE))], JLog::INFO, 'yooniquenet');
				}
			}
		}

		if (!$ZOO_SEF_CATEGORY_PATH) {
			if ($ZOO_SEF_SHOW_PRIMARY && $item->getPrimaryCategoryId()) {
				$catid = $item->getPrimaryCategoryId();
			}
			if ($ZOO_SEF_SHOW_CATEGORY && isset($query['category_id'])) {
				$catid = (int) $query['category_id'];
			}
			if ($ZOO_SEF_SHOW_CATEGORY && !isset($query['category_id']) && $item->getPrimaryCategoryId()) {
				defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   CATEGORY NOT FOUND PICK PRIMARY ", JLog::INFO, 'yooniquenet');
				$catid = $item->getPrimaryCategoryId();
			}
			if ($ZOO_SEF_CATEGORY_ALIAS && $catid) {
				$segments[] = $this->zoo->alias->category->translateIDToAlias($catid);
			} else {
				$category = $this->zoo->table->category->get($catid);
				$segments[] = $this->zoo->string->sluggify($category->name);
			}
		}


		if ($ZOO_SEF_ITEM_ALIAS) {
			$segments[] = $this->zoo->alias->item->translateIDToAlias($item_id);
		} else {
			$segments[] = $this->zoo->string->sluggify($item->name);
		}
		myRemoveFromGETVarsList('item_id', $uri);
		myRemoveFromGETVarsList('category_id', $uri);
		myRemoveFromGETVarsList('layout', $uri);
		break;

	case 'feed':
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   FEED ", JLog::INFO, 'yooniquenet');
		if (isset($query['app_id'])) {
			$segments[] = $this->zoo->alias->application->translateIDToAlias((int) $query['app_id']);
		}
		if ($ZOO_SEF_FEED_SHOW) {
			$segments[] = $ZOO_SEF_FEED;
		}
		$segments[] = $query['type'];
		if (isset($query['category_id']))
			$segments[] = $this->zoo->alias->category->translateIDToAlias((int) $query['category_id']);
		myRemoveFromGETVarsList('app_id', $uri);
		myRemoveFromGETVarsList('category_id', $uri);
		myRemoveFromGETVarsList('type', $uri);
		myRemoveFromGETVarsList('format', $uri);

		break;

	case 'submission':
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   SUBMISSION ", JLog::INFO, 'yooniquenet');
//				return;
		if (isset($app_alias))
			$segments[] = $app_alias;
		if (!isset($query['submission_id'])) {
			$submission_id = (int) $menuparams->get('submission');
		} else {
			$submission_id = (int) $query['submission_id'];
		}
		switch ($query['layout']) {
			case 'submission';
				defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   SUBMISSION LAYOUT ", JLog::INFO, 'yooniquenet');
				if ($ZOO_SEF_SUBMISSION_SHOW) {
					$segments[] = $ZOO_SEF_SUBMISSION;
				}
				if (empty($query['type_id'])) {
					$type_id = $menuparams->get('type');
				} else {
					$type_id = $query['type_id'];
				}
				$segments[] = $this->zoo->alias->submission->translateIDToAlias($submission_id);
				$segments[] = $type_id;
				if (isset($query['submission_hash'])) {
					defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   submission_hash " . $submission_hash, JLog::INFO, 'yooniquenet');
					$segments[] = $query['submission_hash'];
				}
				if (isset($query['item_id']))
					$segments[] = $this->zoo->alias->item->translateIDToAlias((int) $query['item_id']);
				myRemoveFromGETVarsList('redirect', $uri);
				myRemoveFromGETVarsList('submission_id', $uri);
				myRemoveFromGETVarsList('submission_hash', $uri);
				myRemoveFromGETVarsList('type_id', $uri);
				myRemoveFromGETVarsList('item_id', $uri);
				myRemoveFromGETVarsList('layout', $uri);
				break;
			case 'mysubmissions';
				defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   MYSUBMISSIONS LAYOUT ", JLog::INFO, 'yooniquenet');
				if ($ZOO_SEF_SUBMISSION_SHOW) {
					$segments[] = $ZOO_SEF_SUBMISSION;
				}
				if (isset($query['submission_hash'])) {
					defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   submission_hash " . $submission_hash, JLog::INFO, 'yooniquenet');
					$segments[] = $query['submission_hash'];
				}
				$segments[] = $this->zoo->alias->submission->translateIDToAlias((int) $query['submission_id']);
				$segments[] = isset($query['page']) ? $ZOO_SEF_PAGE . $query['page'] : '';
				myRemoveFromGETVarsList('submission_hash', $uri);
				myRemoveFromGETVarsList('page', $uri);
				myRemoveFromGETVarsList('layout', $uri);
				myRemoveFromGETVarsList('submission_id', $uri);
				break;
			default:
				break;
		}
		break;

	default:
		defined('YOONIQUE_DBG') and yoonique_jadd(__METHOD__ . "   DEFAULT ", JLog::INFO, 'yooniquenet');
		// comment, callement
		$dosef = false;
		$segments = null;
		return;
		break;
}
